/*****************************************************************************
 *   hmc5883.c:  for NXP LPC11xx Family Microprocessors
******************************************************************************/
#include "LPC11xx.h"			// LPC11xx Peripheral Registers
#include "type.h"
#include "i2c.h"
#include "timer16.h"
#include "gpio.h"

//gp֐̒`
void i2c_wait_stat(unsigned char wstat); // Xe[^X̓Ǎ
void i2c_tx(unsigned char data, unsigned char wstat); // f[^̑M
unsigned char i2c_rx(unsigned char wstat);  // f[^̎M
void wait_1ms(unsigned short dat);       // dat ms̎ԑ҂
int get_HMC(unsigned char *dat);        // HMC瑪f[^𓾂
int init_HMC(void);                     // HMC̏

unsigned char mag[20];

#define SYSTICK_DELAY		5000


/*******************************************************************************
**   Main Function  main()
*******************************************************************************/
int main (void)
{
  uint32_t i,j;

  SystemInit();
  for (i = 0; i < 1000000; i++);

  // Enable AHB clock to the GPIO
  LPC_SYSCON->SYSAHBCLKCTRL |= (1<<6);

  // Enable AHB clock to the IOCON
  LPC_SYSCON->SYSAHBCLKCTRL |= (1<<16);

  // Enable AHB clock to the I2C
  LPC_SYSCON->SYSAHBCLKCTRL |= (1<<5);

  // Enable AHB clock to the 16-bit counter/timer 0
  LPC_SYSCON->SYSAHBCLKCTRL |= (1<<7);

  // Called for system library in core_cmx.h(x=0 or 3). */
  SysTick_Config( SYSTICK_DELAY );

  GPIOInit();

  // timer16̏
  timer16_0_counter = 0;
  LPC_TMR16B0->PR = 1000;				        // Interrupt and Reset on MR0
  LPC_TMR16B0->MR0 = 0xffff;            // TimerInterval;
  LPC_TMR16B0->MCR = 0;                 // Interrupt and Reset on MR0 */
  LPC_TMR16B0->TCR = 1;                 // enable

  // I2C[q̐ݒ
  LPC_IOCON->PIO0_4 &= ~0x3F;	          // I2C I/O config
  LPC_IOCON->PIO0_4 |= 0x01;		        // I2C SCL
  LPC_IOCON->PIO0_5 &= ~0x3F;	
  LPC_IOCON->PIO0_5 |= 0x01;		        // I2C SDA

  // I2CW[̐ݒ
  LPC_SYSCON->PRESETCTRL |= 0x2;        // I2CZbg
  LPC_I2C->CONCLR = 0x6c;               // I2C̊eXe[^XNA
  LPC_I2C->SCLL   = 660;                // I2C̃NbNg̐ݒ
  LPC_I2C->SCLH   = 660;                // I2C̃NbNg̐ݒ
  LPC_I2C->CONSET = 0x40;               // I2CCl[u

  init_HMC();                           // HMC5883L̏

  while(1)
  {
    get_HMC(mag);                       // f[^i1Oj̎擾
    wait_1ms(2000);                     // 2s҂
  };
}

void i2c_wait_stat(unsigned char wstat)
{
  unsigned char stat;
  do
  {
    stat = LPC_I2C->STAT & 0xff;
  } while(stat != wstat);
}

void i2c_tx(unsigned char data, unsigned char wstat)
{
  int i;
  for (i = 0; i < 100; i++);            // Ԓ
  LPC_I2C->DAT = data;
  LPC_I2C->CONCLR = 0x08;               // I2C݃NA
  i2c_wait_stat(wstat);
}

unsigned char i2c_rx(unsigned char wstat)
{
  int i;
  for (i = 0; i < 100; i++);            // Ԓ
  LPC_I2C->CONCLR = 0x08;               // I2C݃NA
  i2c_wait_stat(wstat);
  return (LPC_I2C->DAT);
}

/***************************************
  1ms~datԑ҂ٰ
***************************************/
void wait_1ms(unsigned short dat)
{
  unsigned short j;
  unsigned long i;

  i = 10 * (unsigned long)dat;          // 0.1ms̃^C}[g

  do
  {
    j = LPC_TMR16B1->TC;                // JE^l̎擾
    while(LPC_TMR16B1->TC == j);        // 0.1ms̎ԑ҂
    i--;                                // iPJEg
  }while (i != 0);                      // i=0(^CAbv)܂ŌJԂ
}

int init_HMC(void)
{
  int i;

  LPC_I2C->CONSET = 0x20;               // start set
  i2c_tx(0x3c, 0x18);                   // AhX𑗐M
  LPC_I2C->CONCLR = 0x20;               // start NA
  i2c_tx(0x0, 0x28);                    // Config. A
  i2c_tx(0x10, 0x28);
  LPC_I2C->CONSET = 0x10;               // stop
  for (i = 0; i < 100; i++);            // Ԓ
  LPC_I2C->CONCLR = 0x2C;               // I2CI
  wait_1ms(100);                        // 100ms҂

  LPC_I2C->CONSET = 0x20;               // start set
  i2c_tx(0x3c, 0x18);                   // AhX𑗐M
  LPC_I2C->CONCLR = 0x20;               // start NA
  i2c_tx(0x1, 0x28);                    // Config. B
  i2c_tx(0x20, 0x28);
  LPC_I2C->CONSET = 0x10;               // stop
  for (i = 0; i < 100; i++);            // Ԓ
  LPC_I2C->CONCLR = 0x2C;               // I2CI
  wait_1ms(100);                        // 100ms҂

  LPC_I2C->CONSET = 0x20;               // start set
  i2c_tx(0x3c, 0x18);                   // AhX𑗐M
  LPC_I2C->CONCLR = 0x20;               // start NA
  i2c_tx(0x2, 0x28);                    // Mode
  i2c_tx(0x1, 0x28);
  LPC_I2C->CONSET = 0x10;               // stop
  for (i = 0; i < 100; i++);            // Ԓ
  LPC_I2C->CONCLR = 0x2C;               // I2CI
  wait_1ms(100);                        // 100ms҂

  return 0;
}

int get_HMC(unsigned char *dat)
{
  int k,i;

  LPC_I2C->CONSET = 0x20;               // start set
  i2c_tx(0x3c, 0x18);                   // AhX𑗐M
  LPC_I2C->CONCLR = 0x20;               // start NA
  i2c_tx(0x0, 0x28);                    // Config. A
  LPC_I2C->CONSET = 0x10;               // stop
  LPC_I2C->CONSET = 0x20;
  LPC_I2C->CONCLR = 0x08;
  for (i = 0; i < 100; i++);            // Ԓ
  i2c_wait_stat(0x08);

  i2c_tx(0x3d, 0x40);                   // Ǎ݃AhX𑗐M

  LPC_I2C->CONCLR = 0x20;               // startNA

  for (k=0; k<=7; k++)
  {
    LPC_I2C->CONSET = 0x04;             // ACK
    dat[k] = i2c_rx(0x50);              // f[^̓Ǎ
  }

  LPC_I2C->CONCLR = 0x04;               // NAKiM̏Ij
  dat[8] = i2c_rx(0x58);                // Ō̃f[^̓Ǎ

  LPC_I2C->CONSET = 0x10;               // stop
  LPC_I2C->CONCLR = 0x2C;
  wait_1ms(100);                        // 100ms҂

  LPC_I2C->CONSET = 0x20;               // start set
  i2c_tx(0x3c, 0x18);                   // AhX𑗐M
  LPC_I2C->CONCLR = 0x20;               // start NA
  i2c_tx(0x2, 0x28);                    // Mode
  i2c_tx(0x1, 0x28);
  LPC_I2C->CONSET = 0x10;               // stop
  for (i = 0; i < 100; i++);            // Ԓ
  LPC_I2C->CONCLR = 0x2C;               // I2CI

  return 0;
}
